/*@ requires length > 0;
    requires \valid(a+(0 .. length));
    ensures \forall integer i; 0<=i<length ==> \result >= a[i];
    ensures \exists integer i; 0<=i<length &&  \result == a[i];
*/
int max_array(int* a, int length) {
  int m = a[0];
  /*@
    loop invariant 0<=i<=length;
    loop invariant \forall integer j; 0<=j<i ==> m >= a[j];
    loop invariant \exists integer j; 0<=j<i &&  m == a[j];

    loop assigns i,m;

    loop variant length - i;
  */
  for (int i = 1; i<length; i++) {
    if (a[i] > m) m = a[i];
  }
  return m;
}

/*
Local Variables:
compile-command: "frama-c-gui -wp -wp-rte max_array.c"
End:
*/
